/**********************************************************
 * 
 * utils.c
 * 
 **********************************************************/


#include "mega_bt.h"

extern char temp[16];

/**********************************************************/

// a psuedo ECG signal
#define NUM  201
unsigned char a_signal[NUM] = 
       {92, 89, 91, 97, 102, 95, 91, 94, 105, 106, 103, 101, 
        104, 112, 116, 111, 110, 111, 120, 122, 116, 110, 112, 
        119, 118, 111, 106, 106, 113, 112, 104, 97, 97, 102, 
        100, 91, 84, 84, 89, 86, 80, 75, 74, 80, 81, 74, 71, 71, 
         77, 78, 75, 70, 73, 79, 81, 75, 73, 75, 83, 82, 78, 72, 
         77, 82, 85, 78, 73, 75, 83, 84, 80, 73, 77, 84, 84, 79, 
         76, 76, 84, 86, 81, 75, 76, 83, 85, 77, 73, 74, 81, 83, 
         78, 73, 74, 82, 82, 77, 74, 75, 82, 82, 77, 73, 75, 82, 
         82, 77, 73, 77, 81, 84, 77, 74, 76, 84, 84, 77, 74, 77, 
         79, 83, 77, 73, 75, 83, 86, 82, 77, 81, 89, 92, 88, 86, 
         90, 95, 97, 89, 86, 88, 93, 90, 84, 77, 77, 81, 82, 76, 
         73, 76, 82, 82, 77, 71, 76, 83, 86, 78, 81, 94, 115, 134, 
        164, 210, 227, 221, 185, 141, 98, 63, 41, 29, 19, 11, 24, 
         41, 58, 62, 68, 73, 82, 84, 80, 77, 80, 86, 89, 83, 79, 82, 
         89, 91, 88, 82, 86, 93, 96, 91, 88, 90, 100, 101, 99 };
    
/*
 * send a signal until a keystroke arrives
 * the format is a stream of x/y values in decimal, separated by CR/LF
 */
void  send_a_signal()
{
int16_t x = 0, i, j;
int16_t y;
int16_t r;

    while( UART_HasByte() == 0)
    {
        x++;

        y = a_signal[x%NUM];  //
        print(itoa(x, temp, 10), ' ' );
        print(itoa(y, temp, 10), ' ' );
        Printf("\n\r");
    
        for(i=0;i<10000;i++)        // just a delay to amke things look real
        {
            j = 1;
        }
                                            
    
    }
    ReceiveByte();      // throw away the char that arrived

}

/**********************************************************/
/* 
 * toggles one of the pins on PORT-D
 * Typically a LED might be connected to such a pin
 *   in thois case a 560 ohm resistor is about right
 */
int16_t toggle(int16_t which)
{
uint8_t g;

    g = inp(PIND);
    if( (g & (1<<which)) == 0)  sbi(PORTD, which);
    else                        cbi(PORTD, which);
    
    return 1;
}

/**********************************************************/
/*
 *  short_delay() 
 *  does something that takes a bit of time 
 *  The delay is about .6mS with a 7.37Mhz xtal
 * it is proportional to crystal speed
 */
void short_delay(void)
{  
    unsigned char i, j;
    for (i=0; i<255; i++) 
        j++;
}

/*
 *  long_delay()
 *  A long delay created by calling short delay
 *  A value of 10 is about 6mS
 *
 */
void long_delay(int16_t n)
{

    while(n-->0)
        short_delay();
}

/**********************************************************/
